-- 战力对比
Lua_ForceRatioMainWindow = class("Lua_ForceRatioMainWindow", Lua_Window);
function Lua_ForceRatioMainWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ForceRatioMainWindow";
	self.skinName = "ForceRatioMainWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/friend/xui_zldb_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ForceRatioMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
	self.roleInfoPanel.content.name = "roleInfoPanel";
	self.roleInfoPanel:setRectAnchor(1);
	self.roleInfoPanel:setAvatarClickOpenWin("Lua_TopLayerPersonalInfoWindow");

	self.ratioItemList = Lua_DragList.new(self.content, 720, 858 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.ratioItemList:setListCell(Lua_ForceRatioItem, 720, 121, 1);
	self.ratioItemList:setLocation(0, 121, 0);
	self.ratioItemList:setRectAnchor(7);
	self.ratioItemList:setRectPivot(7);
	-- self.ratioItemList:setCellSpacing(0, 10);

	self.leftForceNum = Lua_NumberImage.new(self.leftObj);
	self.leftForceNum:setLocation(-288, 283, 0);
	self.leftForceNum.scaleVal = 0.8;
	self.leftForceNum.pivot = 1;
	self.leftForceNum.numOffsetX = -2;
	self.leftForceNum.numAtlas = "number";
	self.leftForceNum.preStr = "xui_zl1_number_0";
	self.leftForceNum:setRectAnchor(7);

	self.rightForceNum = Lua_NumberImage.new(self.rightObj);
	self.rightForceNum:setLocation(346, 283, 0);
	self.rightForceNum.scaleVal = 0.8;
	self.rightForceNum.pivot = -1;
	self.rightForceNum.numOffsetX = -2;
	self.rightForceNum.numAtlas = "number";
	self.rightForceNum.preStr = "xui_zl1_number_0";
	self.rightForceNum:setRectAnchor(7);

	self:updateAdaptHeight();

	local list = DataCenter.friendUtil:getAllRatioIds();
	self.ratioItemList:setArrayData(list);
	self:updateInfo();

	if Lua_WindowUtil.isWindowShowing("Lua_PlayerInfoWindow") then
		Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_ForceRatioMainWindow:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.ratioItemList:setContentRect(720, 858 + self.adaptHeight);
	self:updateAdaptHeight();
end

function Lua_ForceRatioMainWindow:updateAdaptHeight()
	self.ratioSplitSp:SetDimensions(2, 880 + self.adaptHeight);
	LuaUtil.setObjPos(self.leftObj, 0, 720 + self.adaptHeight, 0);
	LuaUtil.setObjPos(self.rightObj, 0, 720 + self.adaptHeight, 0);
end

function Lua_ForceRatioMainWindow:dispose()
	if self.ratioItemList ~= nil then
		self.ratioItemList:dispose();
		self.ratioItemList = nil;
	end
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end

	self:superCall("dispose");
end

function Lua_ForceRatioMainWindow:updateInfo()
	local serverName = DataCenter.roleData.server_prev;
	local nameStr = DataCenter.roleData.name or "";
	self.leftPlayTxt.text = LanUtil.formateStr(162000, serverName);
	self.leftPlayTxt:resetSize();
	local posX = -342 + self.leftPlayTxt.preferredWidth + 10;
	if DataCenter.roleData.sex == 1 then
		self.leftSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_2");
		self.leftSexSp:setLocation(posX, 318);
	else
		self.leftSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_3");
		self.leftSexSp:setLocation(posX, 316);
	end
	self.leftPlayNameTxt.text = nameStr;
	self.leftPlayNameTxt:setLocation(posX + 45, 319);
	self.leftForceNum.num = DataCenter.roleData.force;

	local peakState = DataCenter.friendData.peakState;
	if peakState ~= nil and peakState ~= 0 then
		local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(peakState);
		self.leftNameTxt.text = configData.name;
		self.leftStageSp:setAltas("peak_duel_altas", configData.icon)
		self.leftStageSp:setEnable(true);
		self.leftNonePeakSp:setEnable(false);
		self.leftNonePeakTxt.text = nil;
	else
		self.leftNameTxt.text = nil;
		self.leftStageSp:setEnable(false);
		self.leftNonePeakSp:setEnable(true);
		self.leftNonePeakTxt:setLangValue(162001);
	end

	local dressUpId = DataCenter.roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD);
	local dressInfo = DataCenter.roleUtil:getDressUpVoById(dressUpId);
	if self.selfImg.url ~= dressInfo.halfPicUrl then
		self.selfImg:SetDimensions(0, 0);
		self.selfImg:setUrl(dressInfo.halfPicUrl);
	end

	-- 其他玩家
	serverName = DataCenter.friendData.otherServerPrev or "";
	nameStr = DataCenter.friendData.otherPlayName or "";
	self.rightPlayNameTxt.text = nameStr;
	self.rightPlayNameTxt:resetSize();
	posX = 351 - self.rightPlayNameTxt.preferredWidth - 45;
	if DataCenter.friendData.otherSex == 1 then
		self.rightSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_2");
		self.rightSexSp:setLocation(posX, 318);
	else
		self.rightSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_3");
		self.rightSexSp:setLocation(posX, 316);
	end
	self.rightPlayTxt.text = LanUtil.formateStr(162000, serverName);
	self.rightPlayTxt:setLocation(posX - 10, 319);

	self.rightForceNum.num = DataCenter.friendData.otherForceValue;
	local posX = self.rightForceNum:getItemStartPosX() - 24;
	self.rightFightSp:setLocation(posX, 285);

	peakState = DataCenter.friendData.otherPeakState;
	if peakState ~= nil and peakState ~= 0 then
		configData = DataCenter.peakDuelUtil:getSegmentInfoByid(peakState);
		self.rightNameTxt.text = configData.name;
		self.rightStageSp:setAltas("peak_duel_altas", configData.icon)
		self.rightStageSp:setEnable(true);
		self.rightNonePeakSp:setEnable(false);
		self.rightNonePeakTxt.text = nil;
	else
		self.rightNameTxt.text = nil;
		self.rightStageSp:setEnable(false);
		self.rightNonePeakSp:setEnable(true);
		self.rightNonePeakTxt:setLangValue(162001);
	end

	local dressUpId;
	local otherPlayerInfo = DataCenter.friendData.otherPlayerInfo;
	if otherPlayerInfo ~= nil and otherPlayerInfo.dress_info then
		for i = 1, #otherPlayerInfo.dress_info do
			if otherPlayerInfo.dress_info[i].key == Lua_DressUpDefine.MAINTYPE_HEAD then
				dressUpId = otherPlayerInfo.dress_info[i].value;
				break;
			end
		end
	end
	dressUpId = dressUpId or 301000001;
	local dressInfo = DataCenter.roleUtil:getDressUpVoById(dressUpId);
	if self.otherImg.url ~= dressInfo.halfPicUrl then
		self.otherImg:SetDimensions(0, 0);
		self.otherImg:setUrl(dressInfo.halfPicUrl);
	end
end










-------------------------------------------

Lua_ForceRatioItem = class("Lua_ForceRatioItem", Lua_ListCell);
function Lua_ForceRatioItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioItem_skin");
	-- self:superCall("ctor", p);

end

function Lua_ForceRatioItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selfBar.typeValue = 3;
	self.selfBar.fillMethodValue = 0;
	self.selfBar.fillOrigin = 0;
	self.selfBar:setValue(0);

	self.otherBar.typeValue = 3;
	self.otherBar.fillMethodValue = 0;
	self.otherBar.fillOrigin = 1;
	self.otherBar:setValue(0);

	self.findSp:addClickFuntion(self, self.onClickFindSp)
end

function Lua_ForceRatioItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioItem:setData(data)
	self.data = data;
	local cfg = DataCenter.friendUtil:getRatioCfgAtt(self.data, 0);
	if data == nil or cfg == nil then
		return;
	end

	self.winType = cfg.type or 1;
	self.itemNameTxt.text = cfg.desc;


	self.leftValue = DataCenter.friendData:getForceRatioValue(self.data, false);
	self.rightValue = DataCenter.friendData:getForceRatioValue(self.data, true);

	local maxValue = 1;
	local style = 1; -- 1：己方优势 2：对方优势
	if self.leftValue ~= nil or self.rightValue ~= nil then
		if self.leftValue ~= nil and self.rightValue ~= nil then
			if self.leftValue > self.rightValue then
				maxValue = self.leftValue;
			else
				style = 2;
				maxValue = self.rightValue;
			end
		elseif self.leftValue ~= nil then
			maxValue = self.leftValue;
		elseif self.rightValue ~= nil then
			maxValue = self.rightValue;
			style = 2;
		end
	end
	
	self.selfBar:setMaxValue(maxValue);
	self.selfBar:setValue(self.leftValue or 0);
	self.selfBar:setBarAtlas("friend_altas_2", style == 1 and "xui_zldb_progress_2_f" or "xui_zldb_progress_1_f");
	local str = self.leftValue == nil and LanUtil.getValue(162002) or ""; 
	self.selfBar:setText(str);
	self.selfNumTxt.text = self.leftValue;

	self.otherBar:setMaxValue(maxValue);
	self.otherBar:setValue(self.rightValue or 0);
	self.otherBar:setBarAtlas("friend_altas_2", style == 2 and "xui_zldb_progress_2_f" or "xui_zldb_progress_1_f");

	str = self.rightValue == nil and LanUtil.getValue(162002) or ""; 
	self.otherBar:setText(str);
	self.otherValueTxt.text = self.rightValue;
end

function Lua_ForceRatioItem:onClickFindSp()
	if self.leftValue == nil and self.rightValue == nil then
		OperateAlert.showLangValue(162003);
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();
	if self.data == Lua_FriendUtil.HERORATIO then -- 英雄对比
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetHeroForceRank(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	elseif self.data == Lua_FriendUtil.ARTFACTRATIO then -- 神器对比
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sViewOtherArtifactRatio(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	elseif self.data == Lua_FriendUtil.HOMOLOGATORRATIO then -- 同调器
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sViewOtherHomologatorRatio(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	elseif self.data == Lua_FriendUtil.LEAGUESKILL then -- 公会技巧
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetLeagueSkillInfo(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	elseif self.data == Lua_FriendUtil.BEASTRATIO then -- 异兽对比
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetBeastRatioInfo(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	elseif self.data == Lua_FriendUtil.POTENTIALRATIO then -- 潜能对比
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetPotentialRatioInfo(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	end

	if self.winType == 1 then
		Lua_WindowUtil.openWin("Lua_ForceRatioTypeWindow", Lua_WinParam.ACTION_OPEN, self.data);
	else
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sViewOtherAttributeRatio(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag, self.data);
	end
end