-- 战力对比详情窗口
Lua_ForceRatioTypeAttributeWindow = class("Lua_ForceRatioTypeAttributeWindow", Lua_Window);
function Lua_ForceRatioTypeAttributeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ForceRatioTypeAttributeWindow";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ForceRatioTypeAttributeWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeWindow:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO or -- 潜能
		self.ratioType == Lua_FriendUtil.LEAGUELEVEL or -- 公会等级
		self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);
	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end

function Lua_ForceRatioTypeAttributeWindow:showWin(param)
	self:superCall("showWin", param);

	if self.ratioType ~= param.type then
		if self.ratioPanel ~= nil then
			self.ratioPanel:dispose();
			self.ratioPanel = nil;
		end
	end
	self.ratioType = param.type;

	local panel;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO then -- 潜能 
		panel = Lua_ForceRatioTypeAttributePotentialPanel;
	elseif self.ratioType == Lua_FriendUtil.COLLECTIONITEM then -- 藏品柜
		panel = Lua_ForceRatioTypeAttributeCollectionItemPanel;
	elseif self.ratioType == Lua_FriendUtil.NEW_COLLECTIONITEM then -- 新藏品柜
		panel = Lua_ForceRatioTypeAttributeCollectionItemPanel;
	elseif self.ratioType == Lua_FriendUtil.HOMOLOGATORRATIO then -- 同调器 
		panel = Lua_ForceRatioTypeAttributeHomologatorPanel;
	elseif self.ratioType == Lua_FriendUtil.LEAGUESKILL then -- 公会技巧 
		panel = Lua_ForceRatioTypeAttributeLeagueSkillPanel;
	elseif self.ratioType == Lua_FriendUtil.LEAGUELEVEL then -- 公会等级
		panel = Lua_ForceRatioTypeAttributeLeagueLevelPanel;
	elseif self.ratioType == Lua_FriendUtil.PERSONTITLE then -- 称号
		panel = Lua_ForceRatioTypeAttributePersonTitlePanel;
	elseif self.ratioType == Lua_FriendUtil.ARTFACTRATIO then -- 神器对比
		panel = Lua_ForceRatioTypeAttributeArtfactPanel;
	elseif self.ratioType == Lua_FriendUtil.BEASTRATIO then -- 异兽
		panel = Lua_ForceRatioTypeAttributeBeastPanel;
	end

	self.ratioPanel = panel.new(self.content);
	self.ratioPanel:setData(param, self.ratioType);
end

function Lua_ForceRatioTypeAttributeWindow:dispose()
	if self.ratioPanel ~= nil then
		self.ratioPanel:dispose();
		self.ratioPanel = nil;
	end
	self:superCall("dispose");
end









---------------------------------------------------------------
Lua_ForceRatioTypeAttributeItem = class("Lua_ForceRatioTypeAttributeItem", Lua_ListCell);
function Lua_ForceRatioTypeAttributeItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeItem_skin");
end

function Lua_ForceRatioTypeAttributeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	self.itemBg:setAltas("common_altas_2", data.attr_icon_1);

	local str = LanUtil.formateStr(162027, data.show_name, data.showValue);
	self.descTxt.text = str;
end








---------------------------------------------------------------
Lua_ForceRatioTypeAttributeBasePanel = class("Lua_ForceRatioTypeAttributeBasePanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeBasePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_ForceRatioTypeAttributeBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftRatioList = Lua_DragList.new(self.content, 221, 188, Lua_AxisDefine.Vertical);
	self.leftRatioList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftRatioList:setLocation(-215, 16);
	self.leftRatioList:setRectPivot(1);
	self.leftRatioList:setRectAnchor(1);
	self.leftRatioList:setCellSpacing(0, 10);


	self.rightRatioList = Lua_DragList.new(self.content, 221, 188, Lua_AxisDefine.Vertical);
	self.rightRatioList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightRatioList:setLocation(146, 99);
	self.rightRatioList:setRectAnchor(1);
	self.rightRatioList:setRectPivot(1);
	self.rightRatioList:setCellSpacing(0, 10);

	self.itemHeight = 46;
end

function Lua_ForceRatioTypeAttributeBasePanel:dispose()
	if self.leftRatioList ~= nil then
		self.leftRatioList:dispose();
		self.leftRatioList = nil;
	end
	if self.rightRatioList ~= nil then
		self.rightRatioList:dispose();
		self.rightRatioList = nil;
	end

	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeBasePanel:setData(data, ratioType)
	self.ratioType = ratioType;

	if data == nil then
		return;
	end


	local leftArr;
	local rightArr;
	local single_prop;
	local self_prop_info = data.self_prop_info.prop_list;
	local other_prop_info = data.other_prop_info.prop_list;
	local props = self:getDefaultProp();
	if self_prop_info and #self_prop_info > 0 then
		for i = 1, #self_prop_info do
			single_prop = self_prop_info[i];
			props[single_prop.name] = tonumber(single_prop.value);
		end
	end
	leftArr = DataCenter.attributesUtil:getAttrArrByDic(props);

	props = self:getDefaultProp();
	if other_prop_info and #other_prop_info > 0 then
		for i = 1, #other_prop_info do
			single_prop = other_prop_info[i];
			props[single_prop.name] = tonumber(single_prop.value);
		end
	end
	rightArr = DataCenter.attributesUtil:getAttrArrByDic(props);

	self.leftCount = leftArr:getSize();
	self.rightCount = rightArr:getSize();
	self.leftRatioList:setContentRect(221, self.itemHeight * self.leftCount);
	self.leftRatioList:setArrayData(leftArr);
	self.rightRatioList:setContentRect(221, self.itemHeight * self.rightCount);
	self.rightRatioList:setArrayData(rightArr);
end

function Lua_ForceRatioTypeAttributeBasePanel:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO or -- 潜能
		self.ratioType == Lua_FriendUtil.LEAGUELEVEL or -- 公会等级
		self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);
	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end

function Lua_ForceRatioTypeAttributeBasePanel:getDefaultProp()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 1);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end
	return dic;
end











----------------------------------潜能----------------------------------------------
Lua_ForceRatioTypeAttributePotentialPanel = class("Lua_ForceRatioTypeAttributePotentialPanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributePotentialPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributePotentialPanel_skin");
end

function Lua_ForceRatioTypeAttributePotentialPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftTitleTxt:setLangValue(162004);
	self.rightTitleTxt:setLangValue(162004);
	self.leftMainLineTitleTxt:setLangValue(162024);
	self.rightMainLineTitleTxt:setLangValue(162024);
	self.leftBearPropTitleTxt:setLangValue(162058);
	self.rightBearPropTitleTxt:setLangValue(162058);
	self.leftHeroPropTxt:setLangValue(162059);
	self.rightHeroPropTxt:setLangValue(162059);

	-- 浣熊属性加成
	self.leftBearList = Lua_DragList.new(self.leftBearPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.leftBearList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftBearList:setLocation(-41, -33);
	self.leftBearList:setRectPivot(1);
	self.leftBearList:setRectAnchor(1);
	self.leftBearList:setCellSpacing(0, 10);
	self.leftBearList.canDrag = false;

	self.rightBearList = Lua_DragList.new(self.rightBearPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.rightBearList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightBearList:setLocation(-41, -33);
	self.rightBearList:setRectPivot(1);
	self.rightBearList:setRectAnchor(1);
	self.rightBearList:setCellSpacing(0, 10);
	self.rightBearList.canDrag = false;

	-- 英雄属性加成
	self.leftHeroList = Lua_DragList.new(self.leftHeroPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.leftHeroList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftHeroList:setLocation(-41, -33);
	self.leftHeroList:setRectPivot(1);
	self.leftHeroList:setRectAnchor(1);
	self.leftHeroList:setCellSpacing(0, 10);
	self.leftHeroList.canDrag = false;

	self.rightHeroList = Lua_DragList.new(self.rightHeroPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.rightHeroList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightHeroList:setLocation(-41, -33);
	self.rightHeroList:setRectPivot(1);
	self.rightHeroList:setRectAnchor(1);
	self.rightHeroList:setCellSpacing(0, 10);
	self.rightHeroList.canDrag = false;

	self.itemHeight = 46;
	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributePotentialPanel:dispose()
	if self.leftBearList then
		self.leftBearList:dispose();
		self.leftBearList = nil;
	end
	if self.rightBearList then
		self.rightBearList:dispose();
		self.rightBearList = nil;
	end
	if self.leftHeroList then
		self.leftHeroList:dispose();
		self.leftHeroList = nil;
	end
	if self.rightHeroList then
		self.rightHeroList:dispose();
		self.rightHeroList = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributePotentialPanel:setData(data, ratioType)
	self.ratioType = ratioType;
	if data == nil then
		return;
	end

	local msg = data.msg;
	if msg == nil then
		return;
	end
	local leftLevelId;
	local rightLevelId;

	local obj;
	local prop_info;
	local single_prop;
	local leftBearPropArr;
	local leftHeroPropArr;

	local self_destiny_prop = msg.self_destiny_prop;
	local other_destiny_prop = msg.other_destiny_prop;
	for i = 1, #self_destiny_prop do
		obj = self_destiny_prop[i];
		if obj.type == 1 then -- 英雄属性
			leftLevelId = obj.destiny_level;
			prop_info = obj.prop_info;
			local props = self:getPotentialHeroDefaultProps(); -- 服务端要求的
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			leftHeroPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 2 then -- 浣熊属性
			prop_info = obj.prop_info;
			local props = self:getPotentialBearDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			leftBearPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		end
	end

	local height;
	local posY = -73;
	local detail_height = 32;
	local bearCount = leftBearPropArr:getSize();
	height = self.itemHeight * bearCount;
	self.leftBearList:setContentRect(221, height);
	self.leftBearList:setArrayData(leftBearPropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.leftHeroPropObj, -179, posY, 0);
	local heroCount = leftHeroPropArr:getSize();
	height = self.itemHeight * heroCount;
	self.leftHeroList:setContentRect(221, height);
	self.leftHeroList:setArrayData(leftHeroPropArr);

	local totalBgHeight = 290 + detail_height + (bearCount + heroCount ) * self.itemHeight;
	self.leftBg:SetDimensions(341, totalBgHeight);

	local rightBearPropArr;
	local rightHeroPropArr;
	for i = 1, #other_destiny_prop do
		obj = other_destiny_prop[i];
		if obj.type == 1 then -- 英雄属性
			rightLevelId = obj.destiny_level;
			prop_info = obj.prop_info;
			local props = self:getPotentialHeroDefaultProps();
			if prop_info and #prop_info > 0 then 
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			rightHeroPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 2 then -- 浣熊属性
			prop_info = obj.prop_info;
			local props = self:getPotentialBearDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			rightBearPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		end
	end

	posY = -35;
	bearCount = rightBearPropArr:getSize();
	height = self.itemHeight * bearCount;
	self.rightBearList:setContentRect(221, height);
	self.rightBearList:setArrayData(rightBearPropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.rightHeroPropObj, -179, posY, 0);
	heroCount = rightHeroPropArr:getSize();
	height = self.itemHeight * heroCount;
	self.rightHeroList:setContentRect(221, height);
	self.rightHeroList:setArrayData(rightHeroPropArr);

	totalBgHeight = 250 + detail_height + (bearCount + heroCount ) * self.itemHeight;
	self.rightBg:SetDimensions(341, totalBgHeight);


	local id = leftLevelId or 101;
	id = tonumber(id);
	local roleFateVo = Lua_RoleFateVo.new(id);
	self.leftLevelTxt.text = roleFateVo and roleFateVo.name or "";

	id = rightLevelId or 101;
	id = tonumber(id);
	roleFateVo = Lua_RoleFateVo.new(id);
	self.rightLevelTxt.text = roleFateVo and roleFateVo.name or "";

	local leftValue = DataCenter.friendData:getForceRatioValue(Lua_FriendUtil.POTENTIALRATIO, false);
	self.leftMainLineTxt.text = LanUtil.formateStr(162026, leftValue or 0);

	local rightValue = DataCenter.friendData:getForceRatioValue(Lua_FriendUtil.POTENTIALRATIO, true);
	self.rightMainLineTxt.text = LanUtil.formateStr(162026, rightValue or 0);
end

-- 浣熊默认属性
function Lua_ForceRatioTypeAttributePotentialPanel:getPotentialBearDefaultProps()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 1);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end

	return dic;
end

-- 英雄默认属性
function Lua_ForceRatioTypeAttributePotentialPanel:getPotentialHeroDefaultProps()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 2);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end

	return dic;
end

function Lua_ForceRatioTypeAttributePotentialPanel:onClickGotoTxt()
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);

	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, true);
	end
end







----------------------------------神器----------------------------------------------
Lua_ForceRatioTypeAttributeArtfactPanel = class("Lua_ForceRatioTypeAttributeArtfactPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeArtfactPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeArtfactPanel_skin");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.leftDescTxt_2:setLangValue(162025);
	local forceValue = data.self_prop_info ~= nil and data.self_prop_info.force or 0;
	self.leftDescTxt.text = LanUtil.formateStr(162026, forceValue);


	self.rightTitleTxt:setLangValue(162024);
	self.rightDescTxt_2:setLangValue(162025);
	forceValue = data.other_prop_info ~= nil and data.other_prop_info.force or 0;
	self.rightDescTxt.text = LanUtil.formateStr(162026, forceValue);

	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end









----------------------------------称号----------------------------------------------
Lua_ForceRatioTypeAttributePersonTitlePanel = class("Lua_ForceRatioTypeAttributePersonTitlePanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributePersonTitlePanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributePersonTitlePanel_skin");
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftDescTxt_2.text = nil;
	self.rightDescTxt_2.text = nil;
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);


	self.leftDescTxt.text = LanUtil.formateStr(162026,data.self_prop_info.force or 0);
	self.rightDescTxt.text = LanUtil.formateStr(162026, data.other_prop_info.force or 0);


	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end











----------------------------------公会----------------------------------------------
Lua_ForceRatioTypeAttributeLeagueLevelPanel = class("Lua_ForceRatioTypeAttributeLeagueLevelPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeLeagueLevelPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueLevelPanel_skin");
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162016);
	self.leftDescTxt_2:setLangValue(162024);
	self.leftDescTxt_4:setLangValue(162017);
	self.leftDescTxt_3.text = LanUtil.formateStr(162026,data.self_prop_info.force or 0);

	self.rightTitleTxt:setLangValue(162016);
	self.rightDescTxt_2:setLangValue(162024);
	self.rightDescTxt_4:setLangValue(162017);
	self.rightDescTxt_3.text = LanUtil.formateStr(162026, data.other_prop_info.force or 0);

	-- 公会名称
	local str = "";
	if DataCenter.roleData:isJoinTheLeague() then
		str = LanUtil.formateStr(162018, DataCenter.roleData.league_name, DataCenter.roleData.league_level);
	else
		str = LanUtil.getValue(162019);
	end
	self.leftDescTxt.text = str;

	str = "";
	local otherPlayerInfo = DataCenter.friendData.otherPlayerInfo;
	local league_id = otherPlayerInfo.league_id;
	league_id = league_id ~= nil and tonumber(league_id) or league_id;
	if league_id ~= nil and league_id > 0 then
		str = LanUtil.formateStr(162018, otherPlayerInfo.league_name, otherPlayerInfo.league_level);
	else
		str = LanUtil.getValue(162019);
	end
	self.rightDescTxt.text = str;

	self.leftRatioList:setLocation(-215, -117);
	self.rightRatioList:setLocation(146, -82);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 309 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 275 + self.rightCount * self.itemHeight)
end









----------------------------------藏品柜----------------------------------------------
Lua_ForceRatioTypeAttributeCollectionItemPanel = class("Lua_ForceRatioTypeAttributeCollectionItemPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeCollectionItemPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeCollectionItemPanel_skin");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162007);
	self.rightTitleTxt:setLangValue(162007);
	self.leftDescTxt_1:setLangValue(162008);
	self.rightDescTxt_1:setLangValue(162008)
	

	local lvl = data.self_prop_info ~= nil and data.self_prop_info.value or 0;
	self.leftDescTxt.text = LanUtil.formateStr(162009, lvl);
	lvl = data.other_prop_info ~= nil and data.other_prop_info.value or 0;
	self.rightDescTxt.text = LanUtil.formateStr(162009, lvl);

	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end





----------------------------------同调器----------------------------------------------
Lua_ForceRatioTypeAttributeHomologatorPanel = class("Lua_ForceRatioTypeAttributeHomologatorPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeHomologatorPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeHomologatorPanel_skin");
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);
	self.leftDescTxt_1:setLangValue(162010);
	self.rightDescTxt_1:setLangValue(162010);

	self.leftDescTxt.text = LanUtil.formateStr(162026, data.self_prop_info ~= nil and data.self_prop_info.force or 0);
	self.rightDescTxt.text = LanUtil.formateStr(162026, data.other_prop_info ~= nil and data.other_prop_info.force or 0);

	self.leftRatioList:setLocation(-215, -21);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 216 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end












----------------------------------公会技巧----------------------------------------------
Lua_ForceRatioTypeAttributeLeagueSkillPanel = class("Lua_ForceRatioTypeAttributeLeagueSkillPanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeLeagueSkillPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillPanel_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftDragContainer = Lua_DragContainer.new(self.leftObj, 333, 188, Lua_AxisDefine.Vertical);
	self.leftDragContainer:setLocation(0, -199, 0);
	self.leftDragContainer:setRectPivot(1);
	self.leftDragContainer:setRectAnchor(1);

	self.rightDragContainer = Lua_DragContainer.new(self.rightObj, 333, 188, Lua_AxisDefine.Vertical);
	self.rightDragContainer:setLocation(0, -164, 0);
	self.rightDragContainer:setRectPivot(1);
	self.rightDragContainer:setRectAnchor(1);

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:dispose()
	if self.leftDragContainer ~= nil then
		self.leftDragContainer:dispose();
		self.leftDragContainer = nil;
	end
	if self.rightDragContainer ~= nil then
		self.rightDragContainer:dispose();
		self.rightDragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);

	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:setData(param, ratioType)
	if ratioType == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);
	self.leftDescTxt_1:setLangValue(162014);
	self.rightDescTxt_1:setLangValue(162014);

	self.leftDescTxt.text = LanUtil.formateStr(162026, DataCenter.friendData.myselfLeagueSkillForce);
	self.rightDescTxt.text = LanUtil.formateStr(162026, DataCenter.friendData.otherLeagueSkillDirForce);


	local cell;
	local leftHeight, rightHeight = 0, 0;
	self.leftDragContainer:clearList();
	self.rightDragContainer:clearList();
	local careerList = DataCenter.allianceUtil:getConstConfig("science_career_sort", 5);
	for i = 1, #careerList do
		self.leftDragContainer:addSubContainer(Lua_ForceRatioTypeAttributeLeagueSkillItem, {id = careerList[i], bMyself = true }, false);
		self.rightDragContainer:addSubContainer(Lua_ForceRatioTypeAttributeLeagueSkillItem, {id = careerList[i], bMyself = false }, false);

		cell = self.leftDragContainer.showDragDataList:getItem(i);
		leftHeight = leftHeight + (cell ~= nil and cell.cellHeight or 0);
		cell = self.rightDragContainer.showDragDataList:getItem(i);
		rightHeight = rightHeight + (cell ~= nil and cell.cellHeight or 0);
	end

	self.leftDragContainer:updateChildPos();
	self.leftDragContainer:setContentRect(333, leftHeight);
	self.rightDragContainer:updateChildPos();
	self.rightDragContainer:setContentRect(333, rightHeight);

	self.leftBg:SetDimensions(353, 216 + leftHeight);
	self.rightBg:SetDimensions(353, 180 + rightHeight);
	LuaUtil.setRectSize(self.leftObj, 353, 216 + leftHeight);
	LuaUtil.setRectSize(self.rightObj, 353, 180 + rightHeight);
end







---------------------------------

Lua_ForceRatioTypeAttributeLeagueSkillItem = class("Lua_ForceRatioTypeAttributeLeagueSkillItem", Lua_DragContainerItem);
function Lua_ForceRatioTypeAttributeLeagueSkillItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillItem_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemHeight = 30;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:dispose()
	if self.descItems ~= nil then
		for i = 1, #self.descItems do
			self.descItems[i]:dispose();
			self.descItems[i] = nil;
		end
		self.descItems = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:setData(data)
	if data == nil then
		return;
	end

	local id = data.id;
	local str;
	if id == 1 then
		str = 162043;
	elseif id == 2 then
		str = 162044;
	elseif id == 3 then
		str = 162045;
	elseif id == 4 then
		str = 162046;
	end

	local info = DataCenter.friendData:getLeagueSkillInfo(id, data.bMyself);
	local propArr = DataCenter.attributesUtil:getAttrArrByServer(info ~= nil and info.prop_info or nil);
	self.rightTitleTxt.text = LanUtil.formateStr(str, info ~= nil and info.level or 0);
	self:updateItems(propArr);

	local showStr = propArr ~= nil and propArr:getSize() <= 0 and LanUtil.getValue(162047) or nil;
	self.nonDescTxt.text = showStr;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:updateItems(propArr)
	if self.descItems == nil then
		self.descItems = {};
	end

	local item;
	local startPosX, startPosY = -30, -47;
	local posX, posY = 0, 0;
	local distanceX, distanceY = 155, self.itemHeight;
	local row,col;
	local index;
	local arr = propArr;
	self.len = arr:getSize();
	for i = 1, self.len do
		item = self.descItems[i];
		if item == nil then
			item = Lua_ForceRatioTypeAttributeLeagueSkillSubItem.new(self.content);
			item:setRectAnchor(1);
			self.descItems[i] = item;
		end

		index = i - 1;
		row = Mathf.Floor(index / 2);
		col = index % 2;
		posX = startPosX + col * distanceX;
		posY = startPosY - row * distanceY;
		item:setLocation(posX, posY);
		item:setData(arr[i]);
		item:setEnable(true);
	end

	if self.len < #self.descItems then
		for i = self.len + 1, #self.descItems do
			item = self.descItems[i];
			item:setEnable(false);
		end
	end
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:getWidth()
    return 188;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:getHeight()
    local count = self.len ~= nil and self.len or 1; 
    count = count < 1 and 1 or Mathf.Ceil(count / 2);
    return 48 + count * self.itemHeight;
end





---------------------------------------------------------------
Lua_ForceRatioTypeAttributeLeagueSkillSubItem = class("Lua_ForceRatioTypeAttributeLeagueSkillSubItem", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillSubItem_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	local str = LanUtil.formateStr(162049, data.show_name, data.showValue);
	self.descTxt.text = str;
end













----------------------------------异兽属性对比----------------------------------------------
Lua_ForceRatioTypeAttributeBeastPanel = class("Lua_ForceRatioTypeAttributeBeastPanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeBeastPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeBeastPanel_skin");
end

function Lua_ForceRatioTypeAttributeBeastPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.leftTitleTxt:setLangValue(162053);
	self.rightTitleTxt:setLangValue(162053);
	self.leftTreeTitleTxt:setLangValue(162054);
	self.rightTreeTitleTxt:setLangValue(162054);
	self.leftBeastTitleTxt:setLangValue(162055);
	self.rightBeastTitleTxt:setLangValue(162055);
	self.leftAtlasPropTxt:setLangValue(162056);
	self.rightAtlasPropTxt:setLangValue(162056);

	-- 扶桑树
	self.leftTreeList = Lua_DragList.new(self.leftTreeObj, 221, 188, Lua_AxisDefine.Vertical);
	self.leftTreeList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftTreeList:setLocation(-41, -33);
	self.leftTreeList:setRectPivot(1);
	self.leftTreeList:setRectAnchor(1);
	self.leftTreeList:setCellSpacing(0, 10);
	self.leftTreeList.canDrag = false;

	self.rightTreeList = Lua_DragList.new(self.rightTreeObj, 221, 188, Lua_AxisDefine.Vertical);
	self.rightTreeList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightTreeList:setLocation(-41, -33);
	self.rightTreeList:setRectPivot(1);
	self.rightTreeList:setRectAnchor(1);
	self.rightTreeList:setCellSpacing(0, 10);
	self.rightTreeList.canDrag = false;

	-- 异兽
	self.leftBeastList = Lua_DragList.new(self.leftbeastObj, 221, 188, Lua_AxisDefine.Vertical);
	self.leftBeastList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftBeastList:setLocation(-41, -33);
	self.leftBeastList:setRectPivot(1);
	self.leftBeastList:setRectAnchor(1);
	self.leftBeastList:setCellSpacing(0, 10);
	self.leftBeastList.canDrag = false;

	self.rightBeastList = Lua_DragList.new(self.rightbeastObj, 221, 188, Lua_AxisDefine.Vertical);
	self.rightBeastList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightBeastList:setLocation(-41, -33);
	self.rightBeastList:setRectPivot(1);
	self.rightBeastList:setRectAnchor(1);
	self.rightBeastList:setCellSpacing(0, 10);
	self.rightBeastList.canDrag = false;

	-- 异兽
	self.leftAtlasPropList = Lua_DragList.new(self.leftAtlasPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.leftAtlasPropList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftAtlasPropList:setLocation(-41, -33);
	self.leftAtlasPropList:setRectPivot(1);
	self.leftAtlasPropList:setRectAnchor(1);
	self.leftAtlasPropList:setCellSpacing(0, 10);
	self.leftAtlasPropList.canDrag = false;

	self.rightAtlasPropList = Lua_DragList.new(self.rightAtlasPropObj, 221, 188, Lua_AxisDefine.Vertical);
	self.rightAtlasPropList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightAtlasPropList:setLocation(-41, -33);
	self.rightAtlasPropList:setRectPivot(1);
	self.rightAtlasPropList:setRectAnchor(1);
	self.rightAtlasPropList:setCellSpacing(0, 10);
	self.rightAtlasPropList.canDrag = false;

	self.itemHeight = 46;
end

function Lua_ForceRatioTypeAttributeBeastPanel:dispose()
	if self.leftTreeList then
		self.leftTreeList:dispose();
		self.leftTreeList = nil;
	end
	if self.rightTreeList then
		self.rightTreeList:dispose();
		self.rightTreeList = nil;
	end
	if self.leftBeastList then
		self.leftBeastList:dispose();
		self.leftBeastList = nil;
	end
	if self.rightBeastList then
		self.rightBeastList:dispose();
		self.rightBeastList = nil;
	end
	if self.leftAtlasPropList then
		self.leftAtlasPropList:dispose();
		self.leftAtlasPropList = nil;
	end
	if self.rightAtlasPropList then
		self.rightAtlasPropList:dispose();
		self.rightAtlasPropList = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeBeastPanel:setData(data, ratioType)
	self.ratioType = ratioType;
	if data == nil then
		return;
	end

	local msg = data.msg;
	if msg == nil then
		return;
	end
	
	self.leftForceTxt.text = LanUtil.formateStr(162057, tonumber(msg.self_strange_beasts_force));
	self.rightForceTxt.text = LanUtil.formateStr(162057, tonumber(msg.other_strange_beasts_force));

	local obj;
	local prop_info;
	local treeCount;
	local beastCount;
	local atlasCount;
	local single_prop;
	local leftTreePropArr;
	local leftBeastPropArr;
	local leftAtlasPropArr;
	for i = 1, #msg.self_attribute_info do
		obj = msg.self_attribute_info[i];
		if obj.type == 1 then -- 扶桑树属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastTreeDefaultProps();
			if prop_info and #prop_info > 0 then 
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			leftTreePropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 2 then -- 异兽属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastStarDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			leftBeastPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 3 then -- 图鉴属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastAtlasDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			leftAtlasPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		end
	end

	local height;
	local posY = 54;
	local detail_height = 32;
	treeCount = leftTreePropArr:getSize();
	height = self.itemHeight * treeCount;
	self.leftTreeList:setContentRect(221, height);
	self.leftTreeList:setArrayData(leftTreePropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.leftbeastObj, -179, posY, 0);
	beastCount = leftBeastPropArr:getSize();
	height = self.itemHeight * beastCount;
	self.leftBeastList:setContentRect(221, height);
	self.leftBeastList:setArrayData(leftBeastPropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.leftAtlasPropObj, -179, posY, 0);
	atlasCount = leftAtlasPropArr:getSize();
	height = self.itemHeight * atlasCount;
	self.leftAtlasPropList:setContentRect(221, height);
	self.leftAtlasPropList:setArrayData(leftAtlasPropArr);

	local totalBgHeight = 143 + detail_height * 3 + (treeCount + beastCount + atlasCount) * self.itemHeight;
	self.leftBg:SetDimensions(341, totalBgHeight);



	local rightTreePropArr;
	local rightBeastPropArr;
	local rightAtlasPropArr;
	for i = 1, #msg.other_attribute_info do
		obj = msg.other_attribute_info[i];
		if obj.type == 1 then -- 扶桑树属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastTreeDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			rightTreePropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 2 then -- 异兽属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastStarDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			rightBeastPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		elseif obj.type == 3 then -- 图鉴属性
			prop_info = obj.prop_info;
			local props = self:getStrangeBeastAtlasDefaultProps();
			if prop_info and #prop_info > 0 then
				for i = 1, #prop_info do
					single_prop = prop_info[i];
					props[single_prop.name] = tonumber(single_prop.value);
				end
			end
			rightAtlasPropArr = DataCenter.attributesUtil:getAttrArrByDic(props);
		end
	end

	posY = 54;
	treeCount = rightTreePropArr:getSize();
	height = self.itemHeight * treeCount;
	self.rightTreeList:setContentRect(221, height);
	self.rightTreeList:setArrayData(rightTreePropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.rightbeastObj, -179, posY, 0);
	beastCount = rightBeastPropArr:getSize();
	height = self.itemHeight * beastCount;
	self.rightBeastList:setContentRect(221, height);
	self.rightBeastList:setArrayData(rightBeastPropArr);

	posY = posY - detail_height - height;
	LuaUtil.setObjPos(self.rightAtlasPropObj, -179, posY, 0);
	atlasCount = rightAtlasPropArr:getSize();
	height = self.itemHeight * atlasCount;
	self.rightAtlasPropList:setContentRect(221, height);
	self.rightAtlasPropList:setArrayData(rightAtlasPropArr);

	local totalBgHeight = 143 + detail_height * 3 + (treeCount + beastCount + atlasCount) * self.itemHeight;
	self.rightBg:SetDimensions(341, totalBgHeight);
end


-- 扶桑树默认属性
function Lua_ForceRatioTypeAttributeBeastPanel:getStrangeBeastTreeDefaultProps()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 1);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end

	return dic;
end

-- 异兽属性默认属性
function Lua_ForceRatioTypeAttributeBeastPanel:getStrangeBeastStarDefaultProps()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 2);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end

	return dic;
end

-- 图鉴属性默认属性
function Lua_ForceRatioTypeAttributeBeastPanel:getStrangeBeastAtlasDefaultProps()
	local dic = {};
	local cfg = getConfig("forceradio_type", self.ratioType, "default_props", 3);
	if cfg then
		for i = 1, #cfg do
			dic[cfg[i]] = 0;
		end
	end

	return dic;
end