-- 战力对比类型显示窗口 
Lua_ForceRatioTypeWindow = class("Lua_ForceRatioTypeWindow", Lua_Window);
function Lua_ForceRatioTypeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ForceRatioTypeWindow";
	self.skinName = "ForceRatioTypeWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/friend/xui_zldb_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ForceRatioTypeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
	self.roleInfoPanel.content.name = "roleInfoPanel";
	self.roleInfoPanel:setRectAnchor(1);
	self.roleInfoPanel:setAvatarClickOpenWin("Lua_TopLayerPersonalInfoWindow");

	self.leftForceNum = Lua_NumberImage.new(self.leftObj);
	self.leftForceNum:setLocation(-288, 283, 0);
	self.leftForceNum.scaleVal = 0.8;
	self.leftForceNum.pivot = 1;
	self.leftForceNum.numOffsetX = -2;
	self.leftForceNum.numAtlas = "number";
	self.leftForceNum.preStr = "xui_zl1_number_0";
	self.leftForceNum:setRectAnchor(7);

	self.rightForceNum = Lua_NumberImage.new(self.rightObj);
	self.rightForceNum:setLocation(346, 283, 0);
	self.rightForceNum.scaleVal = 0.8;
	self.rightForceNum.pivot = -1;
	self.rightForceNum.numOffsetX = -2;
	self.rightForceNum.numAtlas = "number";
	self.rightForceNum.preStr = "xui_zl1_number_0";
	self.rightForceNum:setRectAnchor(7);

	self.closeSp:addClickFuntion(self, self.hide);
	self.funcSp:addClickFuntion(self, self.onClickFuncSp)
	self.findBg:addClickFuntion(self, self.onClickFindBg)

	self:updateInfo();
	self:updateAdaptHeight();
end

function Lua_ForceRatioTypeWindow:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self:updateAdaptHeight();
end

function Lua_ForceRatioTypeWindow:showWin(param)
	self:superCall("showWin", param);

	self.ratioType = param;
	local cfg = DataCenter.friendUtil:getRatioCfgAtt(param, 0);
	if cfg == nil then
		return;
	end
	local bShowAttributeBtn = cfg.show_btn == 1;
	self.findObj:SetActive(bShowAttributeBtn);

	self.funcPathId = cfg.func_id;
	local bShow = self.funcPathId ~= nil;
	if not bShow then
		if self.ratioType == Lua_FriendUtil.EQUIPRATIO then -- 装备对比
			bShow = true;
		elseif self.ratioType == Lua_FriendUtil.WEAPONRATIO then -- 神兵对比
			bShow = true;
		end
	end
	if bShow ~= nil then
		self.funcSp:setAltas(cfg.atlas, cfg.sprite);
		self.funcSp:resetSize();
	end
	self.funcSp:setEnable(bShow);

	self:updateListInfo();
end

function Lua_ForceRatioTypeWindow:updateInfo()
	local serverName = DataCenter.roleData.server_prev;
	local nameStr = DataCenter.roleData.name or "";
	self.leftPlayTxt.text = LanUtil.formateStr(162000, serverName);
	self.leftPlayTxt:resetSize();
	local posX = -342 + self.leftPlayTxt.preferredWidth + 10;
	if DataCenter.roleData.sex == 1 then
		self.leftSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_2");
		self.leftSexSp:setLocation(posX, 318);
	else
		self.leftSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_3");
		self.leftSexSp:setLocation(posX, 316);
	end
	self.leftPlayNameTxt.text = nameStr;
	self.leftPlayNameTxt:setLocation(posX + 45, 319);
	self.leftForceNum.num = DataCenter.roleData.force;

	local peakState = DataCenter.friendData.peakState;
	if peakState ~= nil and peakState ~= 0 then
		local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(peakState);
		self.leftNameTxt.text = configData.name;
		self.leftStageSp:setAltas("peak_duel_altas", configData.icon)
		self.leftStageSp:setEnable(true);
		self.leftNonePeakSp:setEnable(false);
		self.leftNonePeakTxt.text = nil;
	else
		self.leftNameTxt.text = nil;
		self.leftStageSp:setEnable(false);
		self.leftNonePeakSp:setEnable(true);
		self.leftNonePeakTxt:setLangValue(162001);
	end

	local dressUpId = DataCenter.roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD);
	local dressInfo = DataCenter.roleUtil:getDressUpVoById(dressUpId);
	if self.selfImg.url ~= dressInfo.halfPicUrl then
		self.selfImg:SetDimensions(0, 0);
		self.selfImg:setUrl(dressInfo.halfPicUrl);
	end

	-- 其他玩家
	serverName = DataCenter.friendData.otherServerPrev or "";
	nameStr = DataCenter.friendData.otherPlayName or "";
	self.rightPlayNameTxt.text = nameStr;
	self.rightPlayNameTxt:resetSize();
	posX = 351 - self.rightPlayNameTxt.preferredWidth - 45;
	if DataCenter.friendData.otherSex == 1 then
		self.rightSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_2");
		self.rightSexSp:setLocation(posX, 318);
	else
		self.rightSexSp:setAltas("friend_altas_2", "xui_cjjs_icon_3");
		self.rightSexSp:setLocation(posX, 316);
	end
	self.rightPlayTxt.text = LanUtil.formateStr(162000, serverName);
	self.rightPlayTxt:setLocation(posX - 10, 319);

	self.rightForceNum.num = DataCenter.friendData.otherForceValue;
	local posX = self.rightForceNum:getItemStartPosX() - 24;
	self.rightFightSp:setLocation(posX, 285);

	peakState = DataCenter.friendData.otherPeakState;
	if peakState ~= nil and peakState ~= 0 then
		configData = DataCenter.peakDuelUtil:getSegmentInfoByid(peakState);
		self.rightNameTxt.text = configData.name;
		self.rightStageSp:setAltas("peak_duel_altas", configData.icon)
		self.rightStageSp:setEnable(true);
		self.rightNonePeakSp:setEnable(false);
		self.rightNonePeakTxt.text = nil;
	else
		self.rightNameTxt.text = nil;
		self.rightStageSp:setEnable(false);
		self.rightNonePeakSp:setEnable(true);
		self.rightNonePeakTxt:setLangValue(162001);
	end

	local dressUpId;
	local otherPlayerInfo = DataCenter.friendData.otherPlayerInfo;
	if otherPlayerInfo ~= nil and otherPlayerInfo.dress_info then
		for i = 1, #otherPlayerInfo.dress_info do
			if otherPlayerInfo.dress_info[i].key == Lua_DressUpDefine.MAINTYPE_HEAD then
				dressUpId = otherPlayerInfo.dress_info[i].value;
				break;
			end
		end
	end
	dressUpId = dressUpId or 301000001;
	local dressInfo = DataCenter.roleUtil:getDressUpVoById(dressUpId);
	if self.otherImg.url ~= dressInfo.halfPicUrl then
		self.otherImg:SetDimensions(0, 0);
		self.otherImg:setUrl(dressInfo.halfPicUrl);
	end
end

function Lua_ForceRatioTypeWindow:updateListInfo()
	local itemCell;
	local posX, posY;
	-- local width, height;
	local itemWidth, itemHeight;
	if self.ratioType == Lua_FriendUtil.HERORATIO then -- 英雄对比 
		itemCell = Lua_ForceRatioHeroItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 95;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.RUNERATIO then -- 符石对比
		itemCell = Lua_ForceRatioRuneItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 95;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.EQUIPRATIO then -- 装备对比
		itemCell = Lua_ForceRatioEquipItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 157;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.TOTEMRATIO then -- 图腾对比
		itemCell = Lua_ForceRatioTotemItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 159;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.ARTFACTRATIO then -- 神器对比
		itemCell = Lua_ForceRatioArtifactItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 95;
		self.listWidth, self.listHeight = 699, 753;
	elseif self.ratioType == Lua_FriendUtil.WEAPONRATIO then -- 神兵对比
		itemCell = Lua_ForceRatioWeaponItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 95;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.HOMOLOGATORRATIO then -- 同调器
		itemCell = Lua_ForceRatioHomologatorItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 699, 95;
		self.listWidth, self.listHeight =  704, 753;
	elseif self.ratioType == Lua_FriendUtil.TACTICRATIO then -- 战法对比
		itemCell = Lua_ForceRatioTacticItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 684, 95;
		self.listWidth, self.listHeight = 684, 790;
	elseif self.ratioType == Lua_FriendUtil.BEASTRATIO then -- 异兽对比
		itemCell = Lua_ForceRatioBeastItem;
		posX, posY = 0, 145;
		itemWidth, itemHeight = 699, 95;
		self.listWidth, self.listHeight = 699, 753;
	end
	if itemCell == nil then
		return;
	end

	if self.ratioItemList == nil then
		self.ratioItemList = Lua_DragList.new(self.content, self.listWidth, self.listHeight + self.adaptHeight, Lua_AxisDefine.Vertical);
		self.ratioItemList:setListCell(itemCell, itemWidth, itemHeight, 1);
		self.ratioItemList:setLocation(posX, posY);
		self.ratioItemList:setRectAnchor(7);
		self.ratioItemList:setRectPivot(7);
		self.ratioItemList:setCellSpacing(0, 10);
	end

	local list;
	if self.ratioType == Lua_FriendUtil.BEASTRATIO then -- 异兽对比
		list = DataCenter.friendUtil.beastRatioIds;
	else
		list = DataCenter.friendData:getForceRatioList(self.ratioType)
	end
	self.ratioItemList:setArrayData(list);
end

function Lua_ForceRatioTypeWindow:updateAdaptHeight()
	self.closeSp:setLocation(331, 937 + self.adaptHeight);
	self.ratioListBg:SetDimensions(720, 867 + self.adaptHeight);
	LuaUtil.setObjPos(self.leftObj, 0, 720 + self.adaptHeight, 0);
	LuaUtil.setObjPos(self.rightObj, 0, 720 + self.adaptHeight, 0);

	if self.ratioItemList ~= nil then
		self.ratioItemList:setContentRect(self.listWidth, self.listHeight + self.adaptHeight);
	end
end

function Lua_ForceRatioTypeWindow:onClickFuncSp()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.EQUIPRATIO then --装备对比
		local myselfInfo = DataCenter.friendData.myselfHeroArr;
		if myselfInfo == nil or myselfInfo:getSize() <= 0 then
			OperateAlert.showLangValue(162028);
		else
			local heroVo = myselfInfo[1];
			if DataCenter.heroUtil:getTabState(1, heroVo) then
				DataCenter.heroUtil:onOpenAttrSingleWindow(heroVo.unique_id, 1);
			else
				OperateAlert.showLangValue(162029);
			end
		end
		return;
	elseif self.ratioType == Lua_FriendUtil.WEAPONRATIO then -- 神兵对比
		local heroVo = DataCenter.friendData:getHasWeaponHero();
		if heroVo == nil then
			OperateAlert.showLangValue(162048);
		else
			if DataCenter.heroUtil:getTabState(6, heroVo) then
				DataCenter.heroUtil:onOpenAttrSingleWindow(heroVo.unique_id, 6);
			else
				OperateAlert.showLangValue(162029);
			end
		end
		return;
	elseif self.ratioType == Lua_FriendUtil.TACTICRATIO then -- 战法对比
		local myselfInfo = DataCenter.friendData.myselfHeroArr;
		if myselfInfo == nil or myselfInfo:getSize() <= 0 then
			OperateAlert.showLangValue(162028);
		else
			local heroVo = myselfInfo[1];
			if DataCenter.heroUtil:getTabState(1, heroVo) then
				DataCenter.heroUtil:onOpenAttrSingleWindow(heroVo.unique_id, 1);
			else
				OperateAlert.showLangValue(162029);
			end
		end
		return;
	elseif self.ratioType == Lua_FriendUtil.HERORATIO or --英雄对比
		   self.ratioType == Lua_FriendUtil.ARTFACTRATIO or -- 神器对比
		   self.ratioType == Lua_FriendUtil.RUNERATIO or -- 符石对比
		   self.ratioType == Lua_FriendUtil.BEASTRATIO -- 异兽对比
	then  
		bCloseOther = true;
	end
	DataCenter.funcPathUtil:gotoFunction(self.funcPathId, bCloseOther);
end

function Lua_ForceRatioTypeWindow:onClickFindBg()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end

	self.clickTime = getTime();
	if self.ratioType == Lua_FriendUtil.BEASTRATIO then-- 异兽对比
		Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetBeastPropInfo(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_FriendProxy"):sViewOtherAttributeRatio(DataCenter.friendData.otherPlayerId, DataCenter.friendData.otherServerFlag, self.ratioType);
end

function Lua_ForceRatioTypeWindow:dispose()
	if self.leftForceNum ~= nil then
		self.leftForceNum:dispose();
		self.leftForceNum = nil;
	end
	if self.rightForceNum ~= nil then
		self.rightForceNum:dispose();
		self.rightForceNum = nil;
	end
	if self.ratioItemList ~= nil then
		self.ratioItemList:dispose();
		self.ratioItemList = nil;
	end
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end

	self:superCall("dispose");
end




-------------------------------英雄对比-----------------------------
Lua_ForceRatioHeroItem = class("Lua_ForceRatioHeroItem", Lua_ListCell);
function Lua_ForceRatioHeroItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioHeroItem_skin");
end

function Lua_ForceRatioHeroItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioHeroItem:dispose()
	if self.leftMonsterItem ~= nil then
		self.leftMonsterItem:dispose();
		self.leftMonsterItem = nil;
	end
	if self.rightMonsterItem ~= nil then
		self.rightMonsterItem:dispose();
		self.rightMonsterItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioHeroItem:setData(data)
	self.data = data;
	
	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self:updateLeftData(myselfInfo:getItem(data));
	self:updateRightData(otherInfo:getItem(data));
end

function Lua_ForceRatioHeroItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioHeroItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftMonsterItem == nil then
			self.leftMonsterItem = Lua_ItemIcon.new(self.leftObj);
			self.leftMonsterItem:setLocation(-299, 0);
			self.leftMonsterItem:setScale(0.66, 0.66);
			self.leftMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftMonsterItem:setData(leftData);
		self.leftHeroNameTxt.text = leftData.name;
		self.leftHeroLevelTxt.text = LanUtil.formateStr(162030, leftData.level);

		local rankNum = DataCenter.friendData.ratioHeroRank[leftData.unique_id];
		if rankNum ~= nil then
			self.leftHeroNameTxt:setLocation(-187, 0);
			self.leftHeroLevelTxt:setLocation(-185, -30);
			self.leftRankBg:setEnable(true);
			self.leftRankTxt.text = LanUtil.formateStr(162034, rankNum, leftData.name)
		else
			self.leftHeroNameTxt:setLocation(-187, 18);
			self.leftHeroLevelTxt:setLocation(-185, -13);
			self.leftRankBg:setEnable(false);
			self.leftRankTxt.text = nil;
		end
	end
end

function Lua_ForceRatioHeroItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightMonsterItem == nil then
			self.rightMonsterItem = Lua_ItemIcon.new(self.rightObj);
			self.rightMonsterItem:setLocation(-24, 0);
			self.rightMonsterItem:setScale(0.66, 0.66);
			self.rightMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.rightMonsterItem:setData(rightData);
		self.rightHeroNameTxt.text = rightData.name;
		self.rightHeroLevelTxt.text = LanUtil.formateStr(162030, rightData.level);

		local rankNum = DataCenter.friendData.ratioHeroRank[rightData.unique_id];
		if rankNum ~= nil then
			self.rightHeroNameTxt:setLocation(-137, 0);
			self.rightHeroLevelTxt:setLocation(-137, -30);
			self.rightRankBg:setEnable(true);
			self.rightRankTxt.text = LanUtil.formateStr(162034, rankNum, rightData.name)
		else
			self.rightHeroNameTxt:setLocation(-137, 18);
			self.rightHeroLevelTxt:setLocation(-137, -13);
			self.rightRankBg:setEnable(false);
			self.rightRankTxt.text = nil;
		end
	end
end












-------------------------------装备对比-----------------------------
Lua_ForceRatioEquipItem = class("Lua_ForceRatioEquipItem", Lua_ListCell);
function Lua_ForceRatioEquipItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioEquipItem_skin");
end

function Lua_ForceRatioEquipItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioEquipItem:dispose()
	if self.leftEquips ~= nil then
		for i = 1, #self.leftEquips do
			self.leftEquips[i]:dispose();
			self.leftEquips[i] = nil;
		end
		self.leftEquips = nil;
	end
	if self.rightEquips ~= nil then
		for i = 1, #self.rightEquips do
			self.rightEquips[i]:dispose();
			self.rightEquips[i] = nil;
		end
		self.rightEquips = nil;
	end
	if self.leftMonsterItem ~= nil then
		self.leftMonsterItem:dispose();
		self.leftMonsterItem = nil;
	end
	if self.rightMonsterItem ~= nil then
		self.rightMonsterItem:dispose();
		self.rightMonsterItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioEquipItem:setData(data)
	self.data = data;
	
	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self:updateLeftData(myselfInfo:getItem(data));
	self:updateRightData(otherInfo:getItem(data));
end

function Lua_ForceRatioEquipItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioEquipItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftMonsterItem == nil then
			self.leftMonsterItem = Lua_ItemIcon.new(self.leftObj);
			self.leftMonsterItem:setLocation(-299, 0);
			self.leftMonsterItem:setScale(0.66, 0.66);
			self.leftMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftMonsterItem:setData(leftData);
		self:updateleftEquips(leftData.equipTipsInfo);
	end
end

function Lua_ForceRatioEquipItem:updateleftEquips(equipData)
	if self.leftEquips == nil then
		self.leftEquips = {};
	end

	local tvo;
	local item;
	local leftEquipPos = { {-173, 37}, {-92, 37}, {-173, -39}, {-92, -39}};
	for i = 1, #leftEquipPos do
		item = self.leftEquips[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.leftObj);
			item:setScale(0.6, 0.6);
			item:setCanClick(true);
			self.leftEquips[i] = item;
		end

		if equipData[i] == nil then
			item:setData(nil);
			item:setShadow(true, "hero_equip_altas", DataCenter.equipUtil:getEquipShadow(i, 2));
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
	        item:setShadow(false);
			item:setData(equipData[i]);
		end
		item:setEnable(true);
		item:setLocation(leftEquipPos[i][1], leftEquipPos[i][2]);
	end
end

function Lua_ForceRatioEquipItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightMonsterItem == nil then
			self.rightMonsterItem = Lua_ItemIcon.new(self.rightObj);
			self.rightMonsterItem:setLocation(-24, 0);
			self.rightMonsterItem:setScale(0.66, 0.66);
			self.rightMonsterItem:setClick(self, self.onClickMonsterItem);
		end
		self.rightMonsterItem:setData(rightData);
		self:updateRightEquips(rightData.equipTipsInfo);
	end
end

function Lua_ForceRatioEquipItem:updateRightEquips(equipData)
	if self.rightEquips == nil then
		self.rightEquips = {};
	end

	local tvo;
	local item;
	local rightEquipPos = { {-235, 37}, {-153, 37}, {-235, -39}, {-153, -39}};
	for i = 1, #rightEquipPos do
		item = self.rightEquips[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.rightObj);
			item:setScale(0.6, 0.6);
			item:setCanClick(true);
			self.rightEquips[i] = item;
		end

		if equipData[i] == nil then
			item:setData(nil);
			item:setShadow(true, "hero_equip_altas", DataCenter.equipUtil:getEquipShadow(i, 2));
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
	        item:setShadow(false);
			item:setData(equipData[i]);
		end
		item:setEnable(true);
		item:setLocation(rightEquipPos[i][1], rightEquipPos[i][2]);
	end
end












-------------------------------符石对比-----------------------------
Lua_ForceRatioRuneItem = class("Lua_ForceRatioRuneItem", Lua_ListCell);
function Lua_ForceRatioRuneItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioRuneItem_skin");
end

function Lua_ForceRatioRuneItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioRuneItem:dispose()
	if self.leftRunes ~= nil then
		for i = 1, #self.leftRunes do
			self.leftRunes[i]:dispose();
			self.leftRunes[i] = nil;
		end
		self.leftRunes = nil;
	end
	if self.rightRunes ~= nil then
		for i = 1, #self.rightRunes do
			self.rightRunes[i]:dispose();
			self.rightRunes[i] = nil;
		end
		self.rightRunes = nil;
	end
	if self.leftMonsterItem ~= nil then
		self.leftMonsterItem:dispose();
		self.leftMonsterItem = nil;
	end
	if self.rightMonsterItem ~= nil then
		self.rightMonsterItem:dispose();
		self.rightMonsterItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioRuneItem:setData(data)
	self.data = data;
	
	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self:updateLeftData(myselfInfo:getItem(data));
	self:updateRightData(otherInfo:getItem(data));
end

function Lua_ForceRatioRuneItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioRuneItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftMonsterItem == nil then
			self.leftMonsterItem = Lua_ItemIcon.new(self.leftObj);
			self.leftMonsterItem:setLocation(-299, 0);
			self.leftMonsterItem:setScale(0.66, 0.66);
			self.leftMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftMonsterItem:setData(leftData);
		self:updateleftRunes(leftData.runsTipsInfo);
	end
end

function Lua_ForceRatioRuneItem:updateleftRunes(runesData)
	if self.leftRunes == nil then
		self.leftRunes = {};
	end

	local tvo;
	local item;
	local leftRunesPos = { {-176, 0}, {-88, 0} };
	for i = 1, #leftRunesPos do
		item = self.leftRunes[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.leftObj);
			item:setCanClick(true);
			item:setScale(0.66, 0.66);
			self.leftRunes[i] = item;
		end

		if runesData[i] == nil then
			item:setData(nil);
			item:setShadow(true, "common_altas_4", "ui_zb_icon_02");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		elseif type(runesData[i]) == "number" then
			tvo = DataCenter.runesData:getRunesVoByUid(runesData[i]) or {};
	        item:setShadow(false);
			item:setData(tvo);
			item:showText(4, nil);
		else
	        item:setShadow(false);
			item:setData(runesData[i]);
		end
		item:setLocation(leftRunesPos[i][1], leftRunesPos[i][2]);
	end
end

function Lua_ForceRatioRuneItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightMonsterItem == nil then
			self.rightMonsterItem = Lua_ItemIcon.new(self.rightObj);
			self.rightMonsterItem:setLocation(-24, 0);
			self.rightMonsterItem:setScale(0.66, 0.66);
			self.rightMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.rightMonsterItem:setData(rightData);
		self:updateRightRunes(rightData.rune_info);
	end
end

function Lua_ForceRatioRuneItem:updateRightRunes(runesData)
	if self.rightRunes == nil then
		self.rightRunes = {};
	end

	local tvo;
	local item;
	local rightRunesPos = { {-238, 0}, {-151, 0}};
	for i = 1, #rightRunesPos do
		item = self.rightRunes[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.rightObj);
			item:setScale(0.66, 0.66);
			item:setCanClick(true);
			self.rightRunes[i] = item;
		end

		if runesData[i] == nil then
			item:setData(nil);
			item:setShadow(true, "common_altas_4", "ui_zb_icon_02");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
			tvo = Lua_RunesVo.new(runesData[i].rune.id);
	        tvo:fromServer(runesData[i].rune);
	        item:setShadow(false);
			item:setData(tvo);
		end
		item:setLocation(rightRunesPos[i][1], rightRunesPos[i][2]);
	end
end







-------------------------------神器对比-----------------------------
Lua_ForceRatioArtifactItem = class("Lua_ForceRatioArtifactItem", Lua_ListCell);
function Lua_ForceRatioArtifactItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioArtifactItem_skin");
end

function Lua_ForceRatioArtifactItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioArtifactItem:dispose()
	if self.leftArtifactItem ~= nil then
		self.leftArtifactItem:dispose();
		self.leftArtifactItem = nil;
	end
	if self.rightArtifactItem ~= nil then
		self.rightArtifactItem:dispose();
		self.rightArtifactItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioArtifactItem:setData(data)
	self.data = data;
	
	local myselfInfo = DataCenter.friendData.artifactRatioIds or {};
	local otherInfo = DataCenter.friendData.otherArtifactRatioIds or {};
	self:updateLeftData(myselfInfo[data]);
	self:updateRightData(otherInfo[data]);
end

function Lua_ForceRatioArtifactItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftArtifactItem == nil then
			self.leftArtifactItem = Lua_ForceRatioArtifactSubItem.new(self.leftObj);
			self.leftArtifactItem:setLocation(-299, 0);
		end

		local data = DataCenter.artifactData:getArtifactVoById(leftData);
		self.leftArtNameTxt.text = data.name;
		self.leftArtDescTxt.text = data.position;

		local artifactData = DataCenter.friendData:getArtifactRatioItemById(leftData, true);
		if artifactData then
			self.leftArtLevelTxt.text = LanUtil.formateStr(162031, artifactData.level);
			self.leftArtifactItem:setData(artifactData);
		else
			self.leftArtLevelTxt:setLangValue(162037);
			self.leftArtifactItem:setData({id = leftData}, true);
		end
	end
end

function Lua_ForceRatioArtifactItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightArtifactItem == nil then
			self.rightArtifactItem = Lua_ForceRatioArtifactSubItem.new(self.rightObj);
			self.rightArtifactItem:setLocation(-24, 0);
		end

		local data = DataCenter.artifactData:getArtifactVoById(rightData);
		self.rightArtNameTxt.text = data.name;
		self.rightArtDescTxt.text = data.position;

		local artifactData = DataCenter.friendData:getArtifactRatioItemById(rightData, false);
		if artifactData then
			self.rightArtLevelTxt.text = LanUtil.formateStr(162031, artifactData.level);
			self.rightArtifactItem:setData(artifactData);
		else
			self.rightArtLevelTxt:setLangValue(162037);
			self.rightArtifactItem:setData({id = rightData}, true);
		end
	end
end





-- 神器item
Lua_ForceRatioArtifactSubItem = class("Lua_ForceRatioArtifactSubItem", Lua_DisplayObject)
function Lua_ForceRatioArtifactSubItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioArtifactSubItem_skin")
end

function Lua_ForceRatioArtifactSubItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_ForceRatioArtifactSubItem:dispose()
	if self.starList then
		self.starList:dispose()
		self.starList:clear()
		self.starList = nil
	end
	self:superCall("dispose")
end

function Lua_ForceRatioArtifactSubItem:setData(data, bGray)
	self.artifactId = data.id;
	self:updateData(data.star, bGray)
	self.selectedSp:setEnable(data.bUsed == true);
end

function Lua_ForceRatioArtifactSubItem:updateData(starNum, bGray)
	local data = DataCenter.artifactData:getArtifactVoById(self.artifactId)
	self.bg:setAltas("common_altas_1", "xui_common_itembg_"..data.color)
	self.icon:setAltas("raccoon_atlas_2", data.id)
	self.bg:setGray(bGray == true);
	self.icon:setGray(bGray == true);
	self:showStar(starNum, not bGray);
end

function Lua_ForceRatioArtifactSubItem:showStar(starNum, isShow)
	if self.starList == nil then
		self.starList = Array()
	end

	starNum = starNum or 0;
	local arrLen = self.starList:getSize();
	local maxLen = starNum >= arrLen and starNum or arrLen;
	local width = 13;
	local startPosX = -(width * starNum) / 2 + width / 2;
	local starIcon;
	for i = 1, maxLen do
		starIcon = self.starList[i];
		if i > starNum then
			starIcon:setEnable(false);
		else
			if starIcon == nil then
				starIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_09", 0, 0, 0, 0);
				self.starList:add(starIcon);
			end
			starIcon:setLocation(startPosX + ((i - 1) % starNum) * width, -29.5, 0);
			starIcon:setEnable(isShow);
		end
	end
end















-------------------------------神兵对比-----------------------------
Lua_ForceRatioWeaponItem = class("Lua_ForceRatioWeaponItem", Lua_ListCell);
function Lua_ForceRatioWeaponItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioWeaponItem_skin");
end

function Lua_ForceRatioWeaponItem:buildShowItem()
	self:superCall("buildShowItem");

	self.leftWeapImg:addClickFuntion(self, self.onClickLeftWeap);
	self.rightWeapImg:addClickFuntion(self, self.onClickRightWeap);
end

function Lua_ForceRatioWeaponItem:dispose()
	self.leftHeroData = nil;
	self.rightHeroData = nil;
	if self.leftHeroItem ~= nil then
		self.leftHeroItem:dispose();
		self.leftHeroItem = nil;
	end
	if self.rightHeroItem ~= nil then
		self.rightHeroItem:dispose();
		self.rightHeroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioWeaponItem:setData(data)
	self.data = data;
	

	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self.leftHeroData = myselfInfo:getItem(data);
	self.rightHeroData = otherInfo:getItem(data);
	self:updateLeftData(self.leftHeroData);
	self:updateRightData(self.rightHeroData);
end

function Lua_ForceRatioWeaponItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioWeaponItem:onClickLeftWeap()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if self.leftHeroData ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroWeaponSkillWindow", Lua_WinParam.ACTION_OPEN, { data = self.leftHeroData, isSHowAtlas = false });
	end
end

function Lua_ForceRatioWeaponItem:onClickRightWeap()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if self.rightHeroData ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroWeaponSkillWindow", Lua_WinParam.ACTION_OPEN, { data = self.rightHeroData, isSHowAtlas = false });
	end
end

function Lua_ForceRatioWeaponItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftHeroItem == nil then
			self.leftHeroItem = Lua_ItemIcon.new(self.leftObj);
			self.leftHeroItem:setLocation(-299, 0);
			self.leftHeroItem:setScale(0.66, 0.66);
			self.leftHeroItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftHeroItem:setData(leftData);
		local weaponId = leftData.weaponId;

		local warponName;
		local levelStr;
		local noneWeapStr;
		local bShow = weaponId ~= nil and weaponId > 0;
		if bShow then
			local weaponVo;
			if leftData.weapon_id > 0 then
				weaponVo = DataCenter.heroUtil:getHeroWeaponVo(leftData.weapon_id);
				levelStr = LanUtil.formateStr(162035, weaponVo.level);
				self.leftWeapBg:setGray(false);
				self.leftWeapImg:setGray(false);
			else
				weaponVo = DataCenter.heroUtil:getHeroWeaponVo(leftData.weaponId);
				levelStr = LanUtil.getValue(162038);
				self.leftWeapBg:setGray(true);
				self.leftWeapImg:setGray(true);
			end
			warponName = weaponVo.name;
			self.leftWeapImg:setUrl(weaponVo.uiPicUrl);
		else
			noneWeapStr = LanUtil.getValue(162039);
		end

		self.leftWeapBg:setEnable(bShow);
		self.leftWeapImg:setEnable(bShow);
		self.leftNoneWeapTxt.text = noneWeapStr;
		self.leftWeapNameTxt.text = warponName;
		self.leftWeapLevelTxt.text = levelStr;
	end
end

function Lua_ForceRatioWeaponItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData then
		if self.rightHeroItem == nil then
			self.rightHeroItem = Lua_ItemIcon.new(self.rightObj);
			self.rightHeroItem:setLocation(-24, 0);
			self.rightHeroItem:setScale(0.66, 0.66);
			self.rightHeroItem:setClick(self, self.onClickMonsterItem);
		end

		self.rightHeroItem:setData(rightData);
		local weaponId = rightData.weaponId;

		local warponName;
		local levelStr;
		local noneWeapStr;
		local bShow = weaponId ~= nil and weaponId > 0;
		if bShow then
			local weaponVo;
			if rightData.weapon_id > 0 then
				weaponVo = DataCenter.heroUtil:getHeroWeaponVo(rightData.weapon_id);
				levelStr = LanUtil.formateStr(162035, weaponVo.level);
				self.rightWeapBg:setGray(false);
				self.rightWeapImg:setGray(false);
			else
				weaponVo = DataCenter.heroUtil:getHeroWeaponVo(rightData.weaponId);
				levelStr = LanUtil.getValue(162038);
				self.rightWeapBg:setGray(true);
				self.rightWeapImg:setGray(true);
			end
			warponName = weaponVo.name;
			self.rightWeapImg:setUrl(weaponVo.uiPicUrl);
		else
			noneWeapStr = LanUtil.getValue(162039);
		end

		self.rightWeapBg:setEnable(bShow);
		self.rightWeapImg:setEnable(bShow);
		self.rightNoneWeapTxt.text = noneWeapStr;
		self.rightWeapNameTxt.text = warponName;
		self.rightWeapLevelTxt.text = levelStr;
	end
end






-------------------------------同调器-----------------------------
Lua_ForceRatioHomologatorItem = class("Lua_ForceRatioHomologatorItem", Lua_ListCell);
function Lua_ForceRatioHomologatorItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioHomologatorItem_skin");
end

function Lua_ForceRatioHomologatorItem:buildShowItem()
	self:superCall("buildShowItem");

end

function Lua_ForceRatioHomologatorItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioHomologatorItem:setData(data)
	self.data = data;

	local titleStr;
	local leftLevel;
	local rightLevel;
	if self.data == 1 then
		titleStr = LanUtil.getValue(162032);
		leftLevel = DataCenter.friendData.myselfLifeTreeLevel;
		rightLevel = DataCenter.friendData.otherLifeTreeLevel;
		self.leftSp:setAltas("friend_altas_2", "xui_zldb_label_2");
		self.rightSp:setAltas("friend_altas_2", "xui_zldb_label_2");
	else
		titleStr = LanUtil.getValue(162033);
		leftLevel = DataCenter.friendData.myselfHeroPower;
		rightLevel = DataCenter.friendData.otherHeroPower;
		self.leftSp:setAltas("friend_altas_2", "xui_zldb_label_3");
		self.rightSp:setAltas("friend_altas_2", "xui_zldb_label_3");
	end
	self.leftNameTxt.text = titleStr;
	self.leftLevelTxt.text = LanUtil.formateStr(162030, leftLevel);

	self.rightNameTxt.text = titleStr;
	self.rightLevelTxt.text = LanUtil.formateStr(162030, rightLevel);
end













-------------------------------图腾对比-----------------------------
Lua_ForceRatioTotemItem = class("Lua_ForceRatioTotemItem", Lua_ListCell);
function Lua_ForceRatioTotemItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTotemItem_skin");
end

function Lua_ForceRatioTotemItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTotemItem:dispose()
	if self.leftTotems ~= nil then
		for i = 1, #self.leftTotems do
			self.leftTotems[i]:dispose();
			self.leftTotems[i] = nil;
		end
		self.leftTotems = nil;
	end
	if self.rightTotems ~= nil then
		for i = 1, #self.rightTotems do
			self.rightTotems[i]:dispose();
			self.rightTotems[i] = nil;
		end
		self.rightTotems = nil;
	end
	if self.leftMonsterItem ~= nil then
		self.leftMonsterItem:dispose();
		self.leftMonsterItem = nil;
	end
	if self.rightMonsterItem ~= nil then
		self.rightMonsterItem:dispose();
		self.rightMonsterItem = nil;
	end
	self.leftTotemInfo = nil;
	self.rightTotemInfo = nil;
	self:superCall("dispose");
end

function Lua_ForceRatioTotemItem:setData(data)
	self.data = data;
	self.leftTotemInfo = nil;
	self.rightTotemInfo = nil;

	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self:updateLeftData(myselfInfo:getItem(data));
	self:updateRightData(otherInfo:getItem(data));
end

function Lua_ForceRatioTotemItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioTotemItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftMonsterItem == nil then
			self.leftMonsterItem = Lua_ItemIcon.new(self.leftObj);
			self.leftMonsterItem:setLocation(-121, 0);
			self.leftMonsterItem:setScale(0.66, 0.66);
			self.leftMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftMonsterItem:setData(leftData);
		
		local str;
		if leftData.recoTotemSuit ~= nil then
			local bUnLock = DataCenter.heroUtil:getTabState(1, leftData);
			if bUnLock then
				self:updateleftTotem(leftData.totem_info);
				self.leftTotemObj:SetActive(true);
			else
				str = LanUtil.getValue(162040);
				self.leftTotemObj:SetActive(false);
			end
		else
			str = LanUtil.getValue(162041);
			self.leftTotemObj:SetActive(false);
		end
		self.leftNoneTotemTxt.text = str;
	end
end

function Lua_ForceRatioTotemItem:updateleftTotem(totemInfo)
	self.leftTotemInfo = totemInfo;
	if self.leftTotems == nil then
		self.leftTotems = {};
	end

	local tvo;
	local item;
	local totemDir = {};
	local leftTotemPos = { {-35,  39}, {44,  39}, {123,  39}, 
						   {-35, -39}, {44, -39}, {123, -39} };

	local list = totemInfo and totemInfo.totem_item or {};
	for i = 1, #list do
		tvo = Lua_ToolVo.createToolVo(tonumber(list[i].id));
		tvo:fromServer(list[i]);
		totemDir[tvo.part] = tvo;
	end

	for i = 1, #leftTotemPos do
		item = self.leftTotems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.leftTotemObj);
			item:setScale(0.6, 0.6);
			item:setClick(self, self.onCheckLeftTotemInfo);
			self.leftTotems[i] = item;
		end

		if totemDir[i] == nil then
			item:setData(nil);
			item:setShadow(true, "friend_altas_2", "xui_zldb_label_4");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
	        item:setShadow(false);
			item:setData(totemDir[i]);
		end
		item:setLocation(leftTotemPos[i][1], leftTotemPos[i][2]);
	end
end

function Lua_ForceRatioTotemItem:onCheckLeftTotemInfo(data)
	if self.leftTotemInfo == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(data, false, nil, self.leftTotemInfo);
end

function Lua_ForceRatioTotemItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightMonsterItem == nil then
			self.rightMonsterItem = Lua_ItemIcon.new(self.rightObj);
			self.rightMonsterItem:setLocation(120, 0);
			self.rightMonsterItem:setScale(0.66, 0.66);
			self.rightMonsterItem:setClick(self, self.onClickMonsterItem);
		end
		self.rightMonsterItem:setData(rightData);

		local str;
		if rightData.recoTotemSuit ~= nil then
			local otherPlayOpenState = DataCenter.friendData:getForceRatioValue(Lua_FriendUtil.TOTEMRATIO, true);
			local bUnLock = DataCenter.heroUtil:getOtherPlayerTabState(7, rightData, otherPlayOpenState ~= nil);
			if bUnLock then
				
				self:updateRightTotems(rightData.totem_info);
				self.rightTotemObj:SetActive(true);
			else
				str = LanUtil.getValue(162040);
				self.rightTotemObj:SetActive(false);
			end
		else
			str = LanUtil.getValue(162041);
			self.rightTotemObj:SetActive(false);
		end
		self.rightNoneWeapTxt.text = str;
	end
end

function Lua_ForceRatioTotemItem:updateRightTotems(totemInfo)
	self.rightTotemInfo = totemInfo;
	if self.rightTotems == nil then
		self.rightTotems = {};
	end

	local tvo;
	local item;
	local totemDir = {};
	local rightTotemPos = { {-128,  39}, {-49,  39}, {30,  39}, 
						    {-128, -39}, {-49, -39}, {30, -39}};

	local list = totemInfo and totemInfo.totem_item or {};
	for i = 1, #list do
		tvo = Lua_ToolVo.createToolVo(tonumber(list[i].id));
		tvo:fromServer(list[i]);
		totemDir[tvo.part] = tvo;
	end

	for i = 1, #rightTotemPos do
		item = self.rightTotems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.rightTotemObj);
			item:setScale(0.6, 0.6);
			item:setClick(self, self.onCheckRightTotemInfo);
			self.rightTotems[i] = item;
		end
		if totemDir[i] == nil then
			item:setData(nil);
			item:setShadow(true, "friend_altas_2", "xui_zldb_label_4");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
	        item:setShadow(false);
			item:setData(totemDir[i]);
		end
		item:setLocation(rightTotemPos[i][1], rightTotemPos[i][2]);
	end
end

function Lua_ForceRatioTotemItem:onCheckRightTotemInfo(data)
	if self.rightTotemInfo == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(data, false, nil, self.rightTotemInfo);
end















-------------------------------战法对比-----------------------------
Lua_ForceRatioTacticItem = class("Lua_ForceRatioTacticItem", Lua_ListCell);
function Lua_ForceRatioTacticItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTacticItem_skin");
end

function Lua_ForceRatioTacticItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTacticItem:dispose()
	if self.leftMonsterItem ~= nil then
		self.leftMonsterItem:dispose();
		self.leftMonsterItem = nil;
	end
	if self.rightMonsterItem ~= nil then
		self.rightMonsterItem:dispose();
		self.rightMonsterItem = nil;
	end
	if self.leftTacticItem then
		self.leftTacticItem:dispose();
		self.leftTacticItem = nil;
	end
	if self.rightTacticItem then
		self.rightTacticItem:dispose();
		self.rightTacticItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTacticItem:setData(data)
	self.data = data;
	
	local myselfInfo = DataCenter.friendData.myselfHeroArr;
	local otherInfo = DataCenter.friendData.otherHeroArr;
	self:updateLeftData(myselfInfo:getItem(data));
	self:updateRightData(otherInfo:getItem(data));
end

function Lua_ForceRatioTacticItem:onClickMonsterItem(data)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if data ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = data});
	end
end

function Lua_ForceRatioTacticItem:updateLeftData(leftData)
	self.leftObj:SetActive(leftData ~= nil);
	if leftData ~= nil then
		if self.leftMonsterItem == nil then
			self.leftMonsterItem = Lua_ItemIcon.new(self.leftObj);
			self.leftMonsterItem:setLocation(-299, 0);
			self.leftMonsterItem:setScale(0.66, 0.66);
			self.leftMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.leftMonsterItem:setData(leftData);
		self:updateleftTactic(leftData.heroTacticVo);
	end
end

function Lua_ForceRatioTacticItem:updateleftTactic(heroTacticVo)
	if self.leftTacticItem == nil then
		self.leftTacticItem = Lua_ItemIcon.new(self.leftObj);
		self.leftTacticItem:setCanClick(true);
		self.leftTacticItem:setScale(0.66, 0.66);
		self.leftTacticItem:setLocation(-132, 0);
	end

	if heroTacticVo then
		self.leftTacticItem:setShadow(false);
		self.leftTacticItem:setData(heroTacticVo);
		self.leftTacticItem:setTacticWear(nil, nil);
	else
		self.leftTacticItem:setData(nil);
		self.leftTacticItem:setShadow(true, "common_altas_4", "xui_zldb_icon_1");
		self.leftTacticItem:setIconBg("common_altas_1", "xui_common_itembg_0");
	end
end

function Lua_ForceRatioTacticItem:updateRightData(rightData)
	self.rightObj:SetActive(rightData ~= nil);
	if rightData ~= nil then
		if self.rightMonsterItem == nil then
			self.rightMonsterItem = Lua_ItemIcon.new(self.rightObj);
			self.rightMonsterItem:setLocation(-24, 0);
			self.rightMonsterItem:setScale(0.66, 0.66);
			self.rightMonsterItem:setClick(self, self.onClickMonsterItem);
		end

		self.rightMonsterItem:setData(rightData);
		self:updateRightTactic(rightData.heroTacticVo);
	end
end

function Lua_ForceRatioTacticItem:updateRightTactic(heroTacticVo)
	if self.rightTacticItem == nil then
		self.rightTacticItem = Lua_ItemIcon.new(self.rightObj);
		self.rightTacticItem:setCanClick(true);
		self.rightTacticItem:setScale(0.66, 0.66);
		self.rightTacticItem:setLocation(-194, 0);
	end

	if heroTacticVo then
		self.rightTacticItem:setShadow(false);
		self.rightTacticItem:setData(heroTacticVo);
		self.rightTacticItem:setTacticWear(nil, nil);
	else
		self.rightTacticItem:setData(nil);
		self.rightTacticItem:setShadow(true, "common_altas_4", "xui_zldb_icon_1");
		self.rightTacticItem:setIconBg("common_altas_1", "xui_common_itembg_0");
	end
end














-------------------------------异兽对比-----------------------------
Lua_ForceRatioBeastItem = class("Lua_ForceRatioBeastItem", Lua_ListCell);
function Lua_ForceRatioBeastItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioBeastItem_skin");
end

function Lua_ForceRatioBeastItem:buildShowItem()
	self:superCall("buildShowItem");
	self.leftSelectedSp:setEnable(false);
	self.rightSelectedSp:setEnable(false);
end

function Lua_ForceRatioBeastItem:dispose()
	if self.leftBeastItem ~= nil then
		self.leftBeastItem:dispose();
		self.leftBeastItem = nil;
	end
	if self.rightBeastItem ~= nil then
		self.rightBeastItem:dispose();
		self.rightBeastItem = nil;
	end
	if self.myselfBeastVo then
		self.myselfBeastVo:dispose();
		self.myselfBeastVo = nil;
	end
	if self.otherBeastVo then
		self.otherBeastVo:dispose();
		self.otherBeastVo = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioBeastItem:setData(data)
	self.data = data;
	
	self:updateLeftData();
	self:updateRightData();
end

function Lua_ForceRatioBeastItem:updateLeftData()
	self.leftObj:SetActive(self.data ~= nil);
	if self.leftBeastItem == nil then
		self.leftBeastItem = Lua_ItemIcon.new(self.leftObj);
		self.leftBeastItem:setLocation(-299, 0);
		self.leftBeastItem:setScale(0.66, 0.66);
		self.leftBeastItem:setSiblingIndex(self.leftSelectedSp.siblingIndex);
	end

	local beastData = DataCenter.friendData.beastRatioDic or {};
	beastData = beastData[self.data];
	local bActive = beastData ~= nil;
	self.leftBeastItem:setGray(bActive ~= true);

	local bUsed = beastData and beastData.bUsed or false;
	self.leftSelectedSp:setEnable(bUsed);

	if self.data > 0 then
		local starId = beastData and beastData.starId or 0;
		if self.myselfBeastVo == nil then
			self.myselfBeastVo = Lua_StrangeBeastVo.new(self.data);
		else
			self.myselfBeastVo:setData(self.data);
		end

		self.myselfBeastVo.strangeBeastStarId = starId;
		self.leftBeastItem:setData(self.myselfBeastVo);
		self.leftArtNameTxt.text = self.myselfBeastVo.name;

		self.leftArtLevelTxt.text = bActive ~= true and LanUtil.getValue(162050) or nil;
		self.leftArtDescTxt.text = self.myselfBeastVo.force_ratio_desc;
	elseif self.data == -1 then -- 扶桑树
		self.leftArtNameTxt:setLangValue(162051);
		self.leftArtLevelTxt.text = nil;

		local treeLevel = beastData and beastData.starId or 0;
		local str = bActive and LanUtil.formateStr(162052, treeLevel) or LanUtil.getValue(162050);
		self.leftArtDescTxt.text = str;
	end
	self.leftBeastItem:setEnable(self.data > 0);
	self.leftTreeSp:setEnable(self.data == -1);
end

function Lua_ForceRatioBeastItem:updateRightData()
	self.rightObj:SetActive(self.data ~= nil);
	if self.rightBeastItem == nil then
		self.rightBeastItem = Lua_ItemIcon.new(self.rightObj);
		self.rightBeastItem:setLocation(-24, 0);
		self.rightBeastItem:setScale(0.66, 0.66);
		self.rightBeastItem:setSiblingIndex(self.rightSelectedSp.siblingIndex);
	end

	local beastData = DataCenter.friendData.otherBeastRatioDic or {};
	beastData = beastData[self.data];
	local bActive = beastData ~= nil;
	self.rightBeastItem:setGray(bActive ~= true);

	local bUsed = beastData and beastData.bUsed or false;
	self.rightSelectedSp:setEnable(bUsed);

	if self.data > 0 then
		local starId = beastData and beastData.starId or 0;
		if self.otherBeastVo == nil then
			self.otherBeastVo = Lua_StrangeBeastVo.new(self.data);
		else
			self.otherBeastVo:setData(self.data);
		end
		self.otherBeastVo.strangeBeastStarId = starId;
		self.rightBeastItem:setData(self.otherBeastVo);
		self.rightArtNameTxt.text = self.otherBeastVo.name;

		self.rightArtLevelTxt.text = bActive ~= true and LanUtil.getValue(162050) or nil;
		self.rightArtDescTxt.text = self.otherBeastVo.force_ratio_desc;
	elseif self.data == -1 then -- 扶桑树
		self.rightArtNameTxt:setLangValue(162051);
		self.rightArtLevelTxt.text = nil;

		local treeLevel = beastData and beastData.starId or 0;
		local str = bActive and LanUtil.formateStr(162052, treeLevel) or LanUtil.getValue(162050);
		self.rightArtDescTxt.text = str;
	end
	self.rightBeastItem:setEnable(self.data > 0);
	self.rightTreeSp:setEnable(self.data == -1);
end